<?php

if (!defined('ROSTER_INSTALLED') ) {
        exit('Detected invalid access to this file!');
}

$roster_login = new RosterLogin();

if( !$roster_login->getAuthorized($addon['config']['raidtracker_viewaccess']))
{
        print $roster_login->getMessage().
        $roster_login->getLoginForm($addon['config']['raidtracker_viewaccess']);
        return; //To the addon framework
}

require_once( $addon['dir'] . 'inc/raidtracker.class.php' );

$tracker = new RaidTracker();
$itracker = new RaidTrackerItem();

echo "Character loot module";

if( !active_addon('memberslist') )
{
    // Memberslist not installed. Just die for now.
    roster_die( "You will need to install memberslist to use the keys addon display component" );
}

$data = $tracker->GetLoot("char",4);

$memberslist_addon = getaddon('memberslist');

// Include addon's locale files if they exist
foreach( $roster->multilanguages as $lang )
{
    $roster->locale->add_locale_file($memberslist_addon['locale_dir'] . $lang . '.php',$lang);
}

include_once ($memberslist_addon['dir'] . 'inc/memberslist.php');
include_once (ROSTER_LIB . 'item.php');
//$memberlist = new memberslist(array(), $memberslist_addon);
$memberlist = new memberslist(array('group_alts'=>-1));
//SELECT l.*,r.raidID,p.guild_name FROM `roster20_addons_raidtracker_items` l LEFT JOIN `roster20_addons_raidtracker_raids` r ON r.raidID = l.raidFK JOIN `roster20_addons_raidtracker_raidmembers` p ON p.name = l.member WHERE l.member = 'Gaxme' AND r.realm = 'Azjol-Nerub' AND r.faction = 'Alliance' AND (l.color = 'ffa335ee' OR l.color = 'ffff8000' OR l.color = 'ffe6cc80') AND l.deleted = '0' GROUP BY l.itemname ASC ORDER BY r.raidtime ASC,l.itemname ASC

// First define static data
$mainSelect =
    'SELECT '.
    '`l`.`lootID`, '.
    '`l`.`itemname`, '.
	'`l`.`itemref`, '.
    '`l`.`icon`, '.
    '`l`.`boss`, '.
    '`l`.`color`, '.
    '`l`.`loottime`, '.
    '`l`.`member`, '.
    '`l`.`note`, '.
    '`r`.`zone`, '.
	'`r`.`raidID`, '.
	'`p`.`guild_name`, '.
	'`g`.`guild_id`, ';

$mainTables =
    'FROM `'.$roster->db->table('items','raidtracker').'` AS l '.
	'LEFT JOIN `'.$roster->db->table('raids','raidtracker').'` AS r ON `r`.`raidID` = `l`.`raidFK`'.
	'LEFT JOIN `'.$roster->db->table('raidmembers','raidtracker').'` AS p ON `p`.`name` = `l`.`member` '.
	'LEFT JOIN `'.$roster->db->table('guild').'` AS g ON `p`.`guild_name` = `g`.`guild_name` '.
	'WHERE `l`.`member` = "'.$roster->data['name'].'" AND r.realm = "'.$roster->data['server'].'" AND r.faction = "'.$roster->data['faction'].'" AND l.deleted = 0 '.
//    'WHERE `members`.`guild_id` = "'.$roster->data['guild_id'].'" '.
    'GROUP BY `l`.`itemname` '.
    'ORDER BY ';

$always_sort = ' `l`.`member` ASC, `l`.`loottime` DESC, `l`.`itemname` ASC' ;

/*
$FIELD['lootID'] = array (
    'lang_field' => 'lootID',
    'order'    => array( '`l`.`lootID` ASC' ),
    'order_d'    => array( '`l`.`lootID` DESC' ),
//	'value' => array($memberlist,'icon_value'),
    'js_type' => 'ts_number',
    'display' => 3,
);
*/

$FIELD['icon'] = array (
    'lang_field' => 'zone',
    'order'    => array( '`l`.`icon` ASC' ),
    'order_d'    => array( '`l`.`icon` DESC' ),
	'value' => 'icon_value',
    'js_type' => 'ts_string',
    'display' => 3,
);

$FIELD['itemname'] = array (
    'lang_field' => 'itemname',
    'order'    => array( '`l`.`itemname` ASC' ),
    'order_d'    => array( '`l`.`itemname` DESC' ),
//	'value' => array($memberlist,'itemname_value'),
    'js_type' => 'ts_string',
    'display' => 2,
);

$FIELD['member'] = array (
    'lang_field' => 'member',
    'order'    => array( '`l`.`member` ASC' ),
    'order_d'    => array( '`l`.`member` DESC' ),
//	'value' => array($memberlist,'member_value'),
    'js_type' => 'ts_string',
    'display' => 3,
);

$FIELD['guild_name'] = array (
	'lang_field' => 'guild_name',
	'order'		=> array( '`p`.`guild_name` ASC' ),
	'order_d'	=> array( '`p`.`guild_name` DESC' ),
	'value' 	=> 'guild_value',
	'js_type'	=> 'ts_string',
	'display'	=> 3,
);

$FIELD['loottime'] = array (
	'lang_field' => 'loottime',
	'order' => array( '`l`.`loottime` ASC' ),
	'order_d' => array( '`l`.`loottime` DESC' ),
//	'value' => 'loottime_value',
	'js_type' => 'ts_string',
	'display' => 2,
);

$FIELD['boss'] = array (
	'lang_field' => 'boss',
	'order' => array( '`l`.`boss` ASC' ),
	'order_d' => array( '`l`.`boss` DESC' ),
	'js_type' => 'ts_string',
	'display' => 2,
);

$FIELD['zone'] = array (
	'lang_field' => 'zone',
	'order' => array( '`r`.`zone` ASC' ),
	'order_d' => array( '`r`.`zone` DESC' ),
	'js_type' => 'ts_string',
	'display' => 2,
);

// Combine the main query. The '1' is to fix the trailing comma for the fields list.
$mainQuery = $mainSelect . '1 ' . $mainTables;



$memberlist->prepareData($mainQuery, $always_sort, $FIELD, 'lootlist');

echo $memberlist->makeFilterBox();

echo $memberlist->makeToolBar('horizontal');

echo "<br />\n".border('syellow','start')."\n";
echo $memberlist->makeMembersList();
echo border('syellow','end');

//aprint($mainQuery);

/**
 * Controls Output of the Icon Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function icon_value ( $row, $field ) {
	global $roster, $itracker;
	
	if( !empty($row[$field]) ) {
		$icon = $itracker->fetchItemOrArmory($row['itemref'], $row['itemname']);
		
		return $icon;
	} else return '<div style="display:none; ">Nada</div>';
}
/**
 * Controls Output of the Zone Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function zone_value ( $row, $field )
{
	global $roster, $tracker;

	if( !empty($row[$field]) )
	{
		$icon = htmlspecialchars(nl2br($row[$field]));

		$icon = '<img src="'.$tracker->GetRaidIcon($row['zone']).'" style="cursor:help;" '.makeOverlib($icon,$roster->locale->act['zone'],'',1,'',',WRAP').' alt="[]" />';
	}
	else
	{
		$icon = '&nbsp;';
	}

	return '<div style="display:none; ">'.htmlentities($row[$field]).'</div>'.$icon;
}

/**
 * Controls Output of the Guild Name Column
 *
 * @param array $row
 * @return string - Formatted output
 */
function guild_value ( $row, $field )
{
	global $roster;

	if( $row['guild_id'] )
	{
		return '<div style="display:none; ">' . $row['guild_name'] . '</div><a href="' . makelink('guild-memberslist&amp;a=g:' . $row['guild_id']) . '">' . $row['guild_name'] . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row['guild_name'] . '</div>' . $row['guild_name'];
	}
}
/*
if(!empty($data)) {
	foreach( array_keys($data) as $lootid ) {
		$item_id = $data[$lootid]['itemref'];
		$item_n = $data[$lootid]['itemname'];
		if(isset($item_id))
			echo $rtitem->fetchItemOrArmory($item_id,$item_n);
		else continue;
	}

}
*/
?>
