<SCRIPT LANGUAGE="JavaScript" SRC="/roster/addons/raidtracker/js/calendar.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript">
	var cal = new CalendarPopup();
</SCRIPT>
<?php

if (!defined('ROSTER_INSTALLED') ) {
        exit('Detected invalid access to this file!');
}

$roster_login = new RosterLogin();

if( !$roster_login->getAuthorized($addon['config']['raidtracker_viewaccess']))
{
        print $roster_login->getMessage().
        $roster_login->getLoginForm($addon['config']['raidtracker_viewaccess']);
        return; //To the addon framework
}

require_once( $addon['dir'] . 'inc/raidtracker.class.php' );

$tracker = new RaidTracker;
$itracker = new RaidTrackerItem;

if( !active_addon('memberslist') ) {
    // Memberslist not installed. Just die for now.
    roster_die( "You will need to install memberslist to use the raidtracker addon display component" );
}

$defaultoffset = $addon['config']['raidtracker_querydefault'];

// Date parameters
$startdate = isset($_POST['startdate']) ? htmlspecialchars($_POST['startdate'])." 00:00:01" : date("Y-m-d",time()-$defaultoffset)." 00:00:01";
$enddate = isset($_POST['enddate']) ? htmlspecialchars($_POST['enddate'])." 23:59:59" : date("Y-m-d",time())." 23:59:59";
echo "Received start and end: $startdate, $enddate<br>";

// If we get a raid reference, we are looking for specific raid
$raidID = isset($_GET['raidID']) ? htmlspecialchars($_GET['raidID']) : NULL;
echo "Received raidID $raidID<br>";

// If we get a zone reference, we are looking for a specific zone
$zone = isset($_POST['zone']) ? htmlspecialchars($_POST['zone']) : 0;
echo "Received zone $zone<br>";

if($raidID === NULL) {
	$memberslist_addon = getaddon('memberslist');

	// Include addon's locale files if they exist
	foreach( $roster->multilanguages as $lang ) {
		$roster->locale->add_locale_file($memberslist_addon['locale_dir'] . $lang . '.php',$lang);
	}
	
	include_once ($memberslist_addon['dir'] . 'inc/memberslist.php');
	include_once (ROSTER_LIB . 'item.php');
	$memberlist = new memberslist(array('group_alts'=>-1));

	$mainSelect =
		'SELECT '.
		'`r`.`raidID`, '.
		'COUNT(b.boss) AS bosscount, '.
		'COUNT(`l`.`lootID`) AS lootcount, '.
		'`r`.`raidtime`, '.
		'`r`.`instanceID`, '.
		'`r`.`zone`, '.
		'`r`.`note`, '.
		'`r`.`guild_name`, '.
		'`r`.`wipes`, '.
		'`z`.`zone_name`, '.
		'`z`.`zone_id`, '.
		'`z`.`zone_localized`, '.
		'COUNT(`a`.`member`) AS attended, ';
	
	$mainTables =
		'FROM `'.$roster->db->table('raids','raidtracker').'` AS r '.
		'LEFT JOIN `'.$roster->db->table('bosskills','raidtracker').'` AS b ON `b`.`raidFK` = `r`.`raidID` '.
		'JOIN `'.$roster->db->table('items','raidtracker').'` AS l ON `l`.`raidFK` = `r`.`raidID` '.
		'JOIN `'.$roster->db->table('raidjoins','raidtracker').'` AS a ON `a`.`raidFK` = `r`.`raidID` '.
		'LEFT JOIN `'.$roster->db->table('zonelist','raidtracker').'` AS z ON `z`.`zone_localized` = `r`.`zone` '.
		'WHERE `r`.`deleted` = "0" AND r.realm = "'.$roster->data['server'].'" AND r.faction = "'.$roster->data['faction'].'" AND r.deleted = 0 ';
		if($zone != 0)
			$mainTables .= 'AND `z`.`zone_id` = "'.$zone.'"';
		//'AND r.raidID = "'.$raidID.'" '.
		$mainTables .= 'AND `r`.`guild_name` = "'.$roster->data['guild_name'].'" '.
		'AND `r`.`raidtime` > "'.$startdate.'" AND `r`.`raidtime` < "'.$enddate.'" '.
		'GROUP BY r.raidID '.
		'ORDER BY ';
	
	$always_sort = ' `r`.`raidtime` DESC, `r`.`zone` ASC ' ;

	$FIELD['zone'] = array (
		'lang_field' => $roster->locale->act['zone'],
		'order' => array( '`r`.`zone` ASC' ),
		'order_d' => array( '`r`.`zone` DESC' ),
		'value' => 'zone_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);

	$FIELD['instanceID'] = array (
		'lang_field' => $roster->locale->act['instanceid'],
		'order'    => array( '`r`.`instanceID` ASC' ),
		'order_d'    => array( '`r`.`instanceID` DESC' ),
		//'value' => 'instanceid_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);

	$FIELD['raidtime'] = array (
		'lang_field' => $roster->locale->act['raidtime'],
		'order'    => array( '`r`.`raidtime` ASC' ),
		'order_d'    => array( '`r`.`raidtime` DESC' ),
		'value' => 'raidtime_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);

	$FIELD['lootcount'] = array (
		'lang_field' => $roster->locale->act['lootcount'],
		'order'    => array( '`b`.`lootcount` ASC' ),
		'order_d'    => array( '`b`.`lootcount` DESC' ),
		// 'value' => 'wipes_value',
		'js_type' => 'ts_number',
		'display' => 2,
	);

	$FIELD['bosscount'] = array (
		'lang_field' => $roster->locale->act['bosscount'],
		//'order'    => array( '`b`.`bosscount` ASC' ),
		//'order_d'    => array( '`b`.`bosscount` DESC' ),
		// 'value' => 'wipes_value',
		'js_type' => 'ts_number',
		'display' => 2,
	);

	$FIELD['attended'] = array (
		'lang_field' => $roster->locale->act['attendees'],
		//'order'    => array( '`b`.`bosscount` ASC' ),
		//'order_d'    => array( '`b`.`bosscount` DESC' ),
		// 'value' => 'wipes_value',
		'js_type' => 'ts_number',
		'display' => 2,
	);

	$FIELD['wipes'] = array (
		'lang_field' => $roster->locale->act['wipes'],
		'order'    => array( '`r`.`wipes` ASC' ),
		'order_d'    => array( '`r`.`wipes` DESC' ),
		// 'value' => 'wipes_value',
		'js_type' => 'ts_number',
		'display' => 2,
	);

	// Combine the main query. The '1' is to fix the trailing comma for the fields list.
	$mainQuery = $mainSelect . '1 ' . $mainTables;
	
	$memberlist->prepareData($mainQuery, $always_sort, $FIELD, 'raidlist');

	echo $memberlist->makeFilterBox();

	echo $memberlist->makeToolBar('horizontal');

	echo "<br />\n".border('syellow','start')."\n";
	echo "<br />\n<strong>".$roster->locale->act['raidtracker_info']." ".$roster->locale->act['guild_raids']." for<br> ".$roster->data['guild_name']."</strong>\n<hr />";
	echo $tracker->CreateZoneSelectBox('qSelect',$zone,date("Y-m-d",strtotime($startdate)),date("Y-m-d",strtotime($enddate)));
	echo border('syellow','end');

	echo "<br />\n".border('sred','start')."\n";
	echo $memberlist->makeMembersList();
	echo border('sred','end');

	aprint($mainQuery.$always_sort);
	
} else {

	echo border('syellow','start','Raid Tracking',300);
	echo "<table cellspacing='0' cellpadding='0' class='raidtrackerHeader'>";
	setTooltip( 'summary', 'This is the raid summary for raid '.$raidID );
	$ovl = makeOverlib( "".getRaidCount()."", "Total Raid Count" );
	echo "<tr><td ".$ovl.">This is the raid summary for raid ".$raidID."</td></tr>";
	echo "</table>";
	echo border('syellow','end');

	listRaids();
}

/**
 * Controls Output of the Zone Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function zone_value ( $row, $field )
{
	global $roster, $tracker;

	if( !empty($row[$field]) )
	{
		$icon = htmlspecialchars(nl2br($row[$field]));

		$icon = '<img src="'.$tracker->GetRaidIcon($row['zone']).'" style="cursor:help;" '.makeOverlib($icon,$roster->locale->act['zone'],'',1,'',',WRAP').' alt="[]" />';
	}
	else
	{
		$icon = '&nbsp;';
	}

	return '<div style="display:none; ">'.htmlentities($row[$field]).'</div>'.$icon;
}

/**
 * Controls Output of the Member Column
 *
 * @param array $row
 * @return string - Formatted output
 */
function member_value ( $row, $field )
{
	global $roster;

	if( $row['member_id'] )
	{
		return '<div style="display:none; ">' . $row['member'] . '</div><a href="' .
				makelink('char-raidtracker-loot&amp;a=c:' . $row['member_id']) . '" '.
				makeOverlib($roster->locale->act['view_char_loot'],$roster->locale->act['char_loot'],'',1,'',',WRAP').
				'>' . $row['member'] . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row['member'] . '</div>' . $row['member'];
	}
}

/**
 * Controls Output of the loottime Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function raidtime_value ( $row, $field )
{
	global $roster,$addon;

	if( !empty($row['raidID']) )
	{
		$time = date($addon['config']['raidtracker_datedisplay'], strtotime($row[$field]));
		return '<div style="display:none; ">' . $time . '</div><a href="' .
						makelink('guild-raidtracker&amp;raidID=' . $row['raidID']) . '" '.
						makeOverlib($roster->locale->act['view_raid'],$roster->locale->act['h_view_raid'],'',1,'',',WRAP').
						'>' . $time . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row[$field] . '</div>' . $row[$field];
	}
}

function getRaidCount() {
        global $roster;

        $q = "SELECT COUNT(*) FROM `".$roster->db->table('raids','raidtracker')."`;";
        $res = $roster->db->query_first($q);
        if(!$res) {
                echo "Failed to retrieve data!<br>";
                $roster->db->error();
        }
	unset($q);
	return $res;
}

function listRaids() {
	global $roster, $addon;
	global $tracker;

	// This needs to be modified for current guild/realm context
	$q = "SELECT r.*, (SELECT COUNT(b.boss) FROM ".$roster->db->table('bosskills','raidtracker')." WHERE b.raidFK = r.raidID) AS bosscount, COUNT(l.lootID) AS lootcount FROM `".$roster->db->table('raids','raidtracker')."` r ".
	     "LEFT JOIN `".$roster->db->table('bosskills','raidtracker')."` b ON b.raidFK = r.raidID ".
		 'LEFT JOIN `'.$roster->db->table('zonelist','raidtracker').'` AS z ON `z`.`zone_localized` = `r`.`zone` '.
		 'LEFT JOIN `'.$roster->db->table('items','raidtracker').'` AS l ON `l`.`raidFK` = `r`.`raidID` '.
	     "WHERE r.deleted = '0' GROUP BY r.raidID ORDER BY r.raidtime DESC;";
	$res = $roster->db->query($q);
	if(!$res) {
		echo "Failed to retrieve data!<br>";
		$roster->db->error();
	}
	$roster->tpl->assign_vars(array(
			'U_BORDER_S'	=> border('sred','start','Raids', '60%'),
			'U_BORDER_E'	=> border('sred','end'),
			'U_TABLE_S'	=> "<table cellspacing=1 cellpadding=1 border=1 class='raidtrackerHeader' width='100%'>",
			'U_HEADER'	=> "<tr><th>".$roster->locale->act['raidid']."</th><th>".$roster->locale->act['zone']."</th><th>".$roster->locale->act['instanceid']."</th><th>".$roster->locale->act['raidtime']."</th><th>".$roster->locale->act['wipes']."</th><th>".$roster->locale->act['bosses']."</th></tr>",
			'U_TABLE_E'	=> "</table>",
	));
	while( $data = $roster->db->fetch($res) ) {
		$roster->tpl->assign_block_vars('raidlist_row', array(
			'RAIDID'	=> $data['raidID'],
			'ZONE'		=> $data['zone'],
			'ICON'		=> $tracker->GetRaidIcon($data['zone']),
			'INSTANCEID'	=> $data['instanceID'],
			'RAIDTIME'	=> $data['raidtime'],
			'WIPES'		=> $data['wipes'],

			'U_LOOT'	=> makelink('guild-raidtracker-loot&amp;raidid=' . $data['raidID']),
			'U_ATTEND'	=> makelink('guild-raidtracker-attendance&amp;raidid='.$data['raidID']),
			'U_BOSSES'	=> makelink('guild-raidtracker-bosses&amp;raidid='.$data['raidID']),
			'U_RAIDZOOM'	=> makelink('guild-raidtracker&amp;raidid='.$data['raidID']),

			'L_BOSSCOUNT'	=> $data['bosscount'],
		));
	}
	$roster->tpl->set_filenames(array('body' => $addon['basename'] . '/raidlist.html'));
	$roster->tpl->display('body');
}

function drawHeader() {
	global $roster;

	echo border('sred','start','Raids',300);
	echo "<table cellspacing=0 cellpadding=0 class='raidtrackerHeader'>";
	echo "<tr><td ".$ovl1.">".$roster->locale->act['raidid']."</td>".
		 "<td ".$ovl2.">".$roster->locale->act['zone']."</td>".
		 "<td ".$ovl3.">".$roster->locale->act['instanceid']."</td>".
		 "<td ".$ovl4.">".$roster->locale->act['raidtime']."</td>".
		 "<td ".$ovl5.">".$roster->locale->act['wipes']."</td></tr>";
}

function drawFooter() {
        echo "</table>";
        echo border('sred','end');
}
?>
