<?php
/**
* WoWRoster.net WoWRoster
*
* RaidTracker Library
*
* LICENSE: Licensed under the Creative Commons
*          "Attribution-NonCommercial-ShareAlike 2.5" license
*
* @copyright  2002-2007 WoWRoster.net
* @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
* @link       http://www.wowroster.net
* @package    RaidTracker
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
* Installer for RaidTracker Addon
* @package    RaidTracker
* @subpackage Installer
*/
class RaidTrackerInstall
{
    var $active = 1;
    var $icon = 'ability_dualwield';

    var $version = '1.9.9.1028';
    var $wrnet_id = '0';

    var $fullname = 'raidtracker_info';
    var $description = 'raidtracker_desc';
    var $credits = array(
        array( "name"=>        "gaxme [at] vestramater [dot] com",
                "info"=>    "2.0 Revamp Author"),
        array(     "name"=>    "PoloDude",
                "info"=>    "Original 1.7.3 author")
    );

    /**
     * Install Function
     *
     * @return bool
     */
    function install()
    {
        global $installer, $roster, $addon;

        // Master and menu entries
        $installer->add_config("'1','startpage','raidtracker_conf','display','master'");
        $installer->add_config("'110','raidtracker_conf',NULL,'blockframe','menu'");
        $installer->add_config("'120','raidtracker_items',NULL,'blockframe','menu'");
        $installer->add_config("'130','raidtracker_raids',NULL,'blockframe','menu'");
        $installer->add_config("'140','raidtracker_attend',NULL,'blockframe','menu'");
        $installer->add_config("'150','raidtracker_bosses',NULL,'blockframe','menu'");
        $installer->add_config("'160','raidtracker_debug',NULL,'blockframe','menu'");

        // Main config options
        $installer->add_config("'1000', 'raidtracker_minver', 'v1.5.0beta15 (MLdkp)', 'text{100|50', 'raidtracker_conf'");
        $installer->add_config("'1005', 'raidtracker_enable', '1', 'select{Yes^1|No^0', 'raidtracker_conf'");
        $installer->add_config("'1006', 'raidtracker_default_guild','1','function{getGuildList','raidtracker_conf'");
        $installer->add_config("'1010', 'raidtracker_adminaccess','3','access','raidtracker_conf'");
        $installer->add_config("'1020', 'raidtracker_uploadaccess','2','access','raidtracker_conf'");
        $installer->add_config("'1030', 'raidtracker_viewaccess', '1','access','raidtracker_conf'");
        $installer->add_config("'1031', 'raidtracker_playerlink', '1', 'radio{Internal^1|Armory^0', 'raidtracker_conf'");
        $installer->add_config("'1032', 'raidtracker_armorytag', 'character-sheet.xml?r={realm}&n={charname}', 'text{50|100', 'raidtracker_conf'");
        $installer->add_config("'1040', 'raidtracker_tooltips', '1', 'select{Yes^1|No^0', 'raidtracker_conf'");
				$installer->add_config("'1050', 'raidtracker_querydefault', '7776000', 'text{50|25', 'raidtracker_conf'");
        $installer->add_config("'1080', 'raidtracker_datedisplay', 'Y-m-d H:i:s', 'text{100|50', 'raidtracker_conf'");
        $installer->add_config("'1090', 'raidtracker_imgformat', 'gif', 'select{gif^gif|jpg^jpg|png^png', 'raidtracker_conf'");
        $installer->add_config("'1095', 'raidtracker_imageloc', 'images', 'text{50|25', 'raidtracker_conf'");
        $installer->add_config("'1096', 'raidtracker_transdb', '0', 'radio{No^0|Yes^1', 'raidtracker_conf'");

        // Item storage config options
				$installer->add_config("'1200', 'raidtracker_storeitems', '1', 'radio{Yes^1|No^0', 'raidtracker_items'");
				$installer->add_config("'1210', 'raidtracker_minitemlvl', '2', 'select{Poor^0|Common^1|Uncommon^2|Rare^3|Epic^4|Legendary^5|Artifact^6', 'raidtracker_items'");
				$installer->add_config("'1215', 'raidtracker_itemcache_expires', '90', 'text{4|4', 'raidtracker_items'");
				$installer->add_config("'1220', 'raidtracker_storeplayers', '0', 'radio{Yes^1|No^0', 'raidtracker_items'");
				$installer->add_config("'1230', 'raidtracker_itemscombined', '1', 'radio{Yes^1|No^0', 'raidtracker_items'");
        
        // Raid storage config options
        $installer->add_config("'1300', 'raidtracker_timediff', '4', 'text{2|2','raidtracker_raids'");
        $installer->add_config("'1310', 'raidtracker_expandraids', '1', 'radio{Expand^1|Collapse^0', 'raidtracker_raids'");
        $installer->add_config("'1320', 'raidtracker_mergeraids', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
				$installer->add_config("'1322', 'raidtracker_mergelimit', '0', 'text{5|5','raidtracker_raids'");
        $installer->add_config("'1325', 'raidtracker_storeunknown', '0', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        $installer->add_config("'1330', 'raidtracker_storeoldworld', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        $installer->add_config("'1331', 'raidtracker_storebc', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        $installer->add_config("'1332', 'raidtracker_storewlk', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        $installer->add_config("'1333', 'raidtracker_storepvp', '0', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        
        // Attendance storage config options
        $installer->add_config("'1400', 'raidtracker_storeattend', '1', 'radio{Yes^1|No^0', 'raidtracker_attend'");
        $installer->add_config("'1420', 'raidtracker_playerleave', '1', 'radio{Yes^1|No^0', 'raidtracker_attend'");

        // Boss storage config options
        $installer->add_config("'1500', 'raidtracker_storebosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
        $installer->add_config("'1505', 'raidtracker_storebossattend', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
        $installer->add_config("'1510', 'raidtracker_oldbosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
        $installer->add_config("'1511', 'raidtracker_bcbosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
        $installer->add_config("'1512', 'raidtracker_wlkbosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");

        // Debug options
        $installer->add_config("'1600', 'raidtracker_debug', '0', 'select{Full Debug^2|Data Testing^1|Quiet^0', 'raidtracker_debug'");

        // Guild buttons
        $installer->add_menu_button('raidtrackerbutton','guild');
        $installer->add_menu_button('bosstrackerbutton','guild','bosses','ability_creature_cursed_02');
        $installer->add_menu_button('loottrackerbutton','guild','loot','racial_dwarf_findtreasure');
        $installer->add_menu_button('attendancetrackerbutton','guild','attendance','ability_rogue_disguise');
		// Utility buttons
		$installer->add_menu_button('manage_raids','util','manage_raids','ability_hunter_rapidkilling');
		$installer->add_menu_button('manage_loot','util','manage_loot','inv_jewelcrafting_goldenhare');
		$installer->add_menu_button('manage_bosses','util','manage_bosses','ability_druid_lunarguidance');

		// Char buttons
        $installer->add_menu_button('char_raids', 'char','raids','ability_dualwield');
        $installer->add_menu_button('char_bosses','char','bosses','ability_creature_cursed_02');
        $installer->add_menu_button('charloot','char','loot','racial_dwarf_findtreasure');
        // Realm buttons
        $installer->add_menu_button('realm_bosses','realm','bosses','ability_creature_cursed_02');
        $installer->add_menu_button('realmloot','realm','loot','racial_dwarf_findtreasure');

        // Table creation
        // Raid table
        $installer->create_table($installer->table('raids'),"
            `raidID` int(6) NOT NULL AUTO_INCREMENT,
            `raidtime` datetime NOT NULL default '0000-00-00 00:00:00',
            `instanceID` int(12) NOT NULL,
            `end` datetime NOT NULL default '0000-00-00 00:00:00',
            `zone` varchar(100) NOT NULL default '',
            `note` varchar(255) NOT NULL default '',
            `deleted` int(1) default '0',
            `realm` varchar(100) NOT NULL default '',
            `region` varchar(3) NOT NULL default '',
            `guild_name` varchar(100) NOT NULL default '',
            `faction` varchar(20) NOT NULL default '',
            `wipes` int(4) NOT NULL default '0',
            PRIMARY KEY (`raidID`)");

	// Bosskills table
        $installer->create_table($installer->table('bosskills'),"
            `raidFK` int(12) NOT NULL default '0',
            `boss` varchar(100) NOT NULL default '',
            `time` datetime NOT NULL default '0000-00-00 00:00:00',
            `deleted` int(1) default '0',
            KEY `raidFK` (`raidFK`)");

	// Loot table
        $installer->create_table($installer->table('items'),"
            `lootID` int(12) NOT NULL AUTO_INCREMENT,
            `raidFK` int(12) NOT NULL default '0',
            `itemname` varchar(100) NOT NULL default '',
            `itemref` varchar(100) NOT NULL default '',
            `loadnum` int(12) NOT NULL default '0',
            `icon` varchar(100) NOT NULL default '',
            `zone` varchar(100) NOT NULL default '',
            `boss` varchar(100) NOT NULL default '',
            `number` int(12) NOT NULL default '0',
            `color` varchar(10) NOT NULL default 'ffffffff',
            `loottime` datetime NOT NULL default '0000-00-00 00:00:00',
            `member` varchar(100) NOT NULL default '',
            `note` varchar(255) NOT NULL default '',
            `deleted` int(1) default '0',
            PRIMARY KEY (`lootID`)
            ");

	// Attendees per loot table
        $installer->create_table($installer->table('itemattend'),"
            `raidFK` int(12) NOT NULL default '0',
            `lootFK` int(12) NOT NULL default '0',
            `member` varchar(100) NOT NULL default '',
            KEY `raidFK` (`raidFK`)
            ");

	// Attendees per boss table
        $installer->create_table($installer->table('bossattend'),"
            `raidFK` int(12) NOT NULL default '0',
            `boss` varchar(100) NOT NULL default '',
            `member` varchar(100) NOT NULL default '',
                        KEY `name` (`raidFK`)
            ");

	// Member data for all raid attendees
        $installer->create_table($installer->table('raidmembers'),"
            `name` varchar(100) NOT NULL default '',
            `race` varchar(100) NOT NULL default '',
            `class` varchar(100) NOT NULL default '',
            `level` int(11) NOT NULL default '0',
            `guild_name` varchar(100) NOT NULL default '',
            `realm` varchar(100) NOT NULL default '',
            `region` varchar(3) NOT NULL default '',
            `faction` varchar(20) NOT NULL default '',
            KEY `name` (`name`)");

	// Raid join time table
        $installer->create_table($installer->table('raidjoins'),"
            `raidFK` int(12) NOT NULL default '0',
            `datejoin` datetime NOT NULL default '0000-00-00 00:00:00',
            `member` varchar(100) NOT NULL default '',
            KEY `raidFK` (`raidFK`)
            ");

	// Raid leave time table
        $installer->create_table($installer->table('raidleaves'),"
            `raidFK` int(12) NOT NULL default '0',
            `dateleft` datetime NOT NULL default '0000-00-00 00:00:00',
            `member` varchar(100) NOT NULL default '',
            KEY `raidFK` (`raidFK`)
            ");

	// Item data cache (to lessen armory strain)
        $installer->create_table($installer->table('itemcache'),"
            `item_id` int(11) NOT NULL AUTO_INCREMENT,
            `wow_id` varchar(64) NOT NULL default '0:0:0:0:0:0',
            `item_name` varchar(96) NOT NULL default '',
            `item_color` varchar(16) NOT NULL default 'ffffffff',
            `item_texture` varchar(64) NOT NULL default '',
            `item_tooltip` mediumtext,
            `html_tooltip` mediumtext,
            `item_level` int(11) NOT NULL default 0,
            `locale` varchar(4) NOT NULL default 'enUS',
            `last_update` TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
            PRIMARY KEY (`item_id`),
            ");

	// Zone list with locale
	$installer->create_table($installer->table('zonelist'),"
	    `zone_id` int(11) NOT NULL AUTO_INCREMENT,
	    `zone_name` varchar(96) NOT NULL default '',
	    `zone_icon` varchar(64) NOT NULL default '',
	    `zone_nick` varchar(10) NOT NULL default '',
	    `zone_pack` varchar(10) NOT NULL default '',
	    `zone_locale` varchar(4) NOT NULL default 'enUS',
	    `zone_localized` varchar(96) NOT NULL default '',
	    PRIMARY KEY (`zone_id`),
	    ");
	
	// Populate the zone list with default locale values
	$this->sql_reader( ROSTER_ADDONS . "raidtracker/lib/db/zonelist.sql" );
	
	// Boss list with locale
	$installer->create_table($installer->table('bosslist'),"
	    `boss_id` int(11) NOT NULL AUTO_INCREMENT,
	    `boss_name` varchar(96) NOT NULL default '',
	    `boss_zone` varchar(96) NOT NULL default '',
	    `zoneFK` int(11) NOT NULL default 0,
	    `boss_locale` varchar(4) NOT NULL default 'enUS',
	    `boss_localized` varchar(96) NOT NULL default '',
	    PRIMARY KEY (`boss_id`),
	    ");
	
	// Populate the boss list with the default locale values
	$this->sql_reader( ROSTER_ADDONS . "raidtracker/lib/db/bosslist.sql" );

        return true;

    }
    /**
    *  Attemps to read a sql file from the file system
    *  and store it in an array by lines
    *
    * @param string $filename
    */
    function sql_reader( $filename ) {
	    global $roster;
	    if(!file_exists( $filename )) {
		trigger_error("$filename does not exist!", E_USER_WARNING);
		return false;
	    }
	    $sql = file("$filename");
	    
	    for($i = 0; $i < sizeof($sql); $i++) {
		    $roster->db->query($sql[$i]) or roster_die( $roster->db->error(), "SQL_reader error!" );
	    }
	    return true;
    }

    /**
     * Upgrade Function
     *
     * @param string $oldversion
     * @return bool
     */
    function upgrade($oldversion)
    {
        global $installer;

        if( version_compare('1.9.9.1006', $oldversion,'>') == true )
        {
            global $installer;
            $installer->add_config("'1030', 'raidtracker_viewaccess', '3','access','raidtracker_conf'");

        }
        if( version_compare('1.9.9.1007', $oldversion, '>') == true )
        {
            global $installer;
            $installer->remove_config('1030');
            $installer->add_config("'1030', 'raidtracker_viewaccess', '3','access','raidtracker_conf'");
        }
        if( version_compare('1.9.9.1008', $oldversion, '>') == true )
        {
            global $installer;
            $installer->add_config("'1090', 'raidtracker_imgformat', '0', 'select{gif^0|jpg^1|png^2', 'raidtracker_conf'");
        }
        if( version_compare('1.9.9.1009', $oldversion, '>') == true )
        {
            global $installer;
            $installer->add_config("'1095', 'raidtracker_imageloc', 'images', 'text{50|25', 'raidtracker_conf'");
        }
        if( version_compare('1.9.9.1011', $oldversion, '>') == true) {
            global $installer;
            $installer->add_config("'1096', 'raidtracker_transdb', '0', 'radio{No^0|Yes^1', 'raidtracker_conf'");
        }
        if( version_compare('1.9.9.1012', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1210');
            $installer->add_config("'1210', 'raidtracker_minitemlvl', '2', 'select{Poor^0|Common^1|Uncommon^2|Rare^3|Epic^4|Legendary^5|Artifact^6', 'raidtracker_items'");
        }
        if( version_compare('1.9.9.1013', $oldversion, '>') == true) {
            global $installer;
            $installer->add_config("'1325', 'raidtracker_storeunknown', '1','radio{Yes^1|No^0', 'raidtracker_raids'");
                    $installer->add_config("'1331', 'raidtracker_storebc', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
                    $installer->add_config("'1332', 'raidtracker_storewlk', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        }
        if( version_compare('1.9.9.1014', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1430');
            $installer->add_config("'1031', 'raidtracker_playerlink', '1', 'radio{Internal^1|Armory^0', 'raidtracker_conf'");
            $installer->add_config("'1032', 'raidtracker_armorytag', 'character-sheet.xml?r={realm}&n={charname}', 'text{50|100', 'raidtracker_conf'");
        }
        if(version_compare('1.9.9.1015', $oldversion, '>') == true) {
            global $installer;
                    $installer->add_config("'1511', 'raidtracker_bcbosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
            $installer->add_config("'1512', 'raidtracker_wlkbosses', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
            $installer->remove_config('1332');
            $installer->add_config("'1332', 'raidtracker_storewlk', '1', 'radio{Yes^1|No^0', 'raidtracker_raids'");
        }
        if(version_compare('1.9.9.1016', $oldversion, '>') == true) {
            global $installer;
            $installer->add_config("'1006','raidtracker_default_guild','1','function{getGuildList','raidtracker_conf'");
        }
        if(version_compare('1.9.9.1017', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1040');
            $installer->remove_config('1050');
            $installer->remove_config('1060');
            $installer->remove_config('1070');
            $installer->add_config("'1040', 'raidtracker_tooltips', '1', 'select{Yes^1|No^0', 'raidtracker_conf'");
        }
        if(version_compare('1.9.9.1018', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1300');
        }
        if(version_compare('1.9.9.1019', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1410');
        }
        if(version_compare('1.9.9.1020', $oldversion, '>') == true) {
            global $installer;
            $installer->add_config("'1505', 'raidtracker_storebossattend', '1', 'radio{Yes^1|No^0', 'raidtracker_bosses'");
        }
        if(version_compare('1.9.9.1021', $oldversion, '>') == true) {
            global $installer;
            $installer->remove_config('1090');
            $installer->add_config("'1090', 'raidtracker_imgformat', 'gif', 'select{gif^gif|jpg^jpg|png^png', 'raidtracker_conf'");
        }
        if(version_compare('1.9.9.1022', $oldversion, '>') == true) {
            global $installer;
            $installer->add_menu_button('char_raids', 'char','char_raids','ability_dualwield');
        }
		if(version_compare('1.9.9.1023', $oldversion, '>') == true) {
			global $installer;
			$installer->add_config("'1322', 'raidtracker_mergelimit', '0', 'text{5|5','raidtracker_raids'");
	
			$installer->remove_menu_button('raidtrackerbutton');
			$installer->remove_menu_button('bosstrackerbutton');
			$installer->remove_menu_button('loottrackerbutton');
			$installer->remove_menu_button('attendancetrackerbutton');
			$installer->remove_menu_button('char_raids');
			$installer->remove_menu_button('char_bosses');
			$installer->remove_menu_button('charloot');
			$installer->remove_menu_button('realm_bosses');
			$installer->remove_menu_button('realmloot');
	
			$installer->add_menu_button('raidtrackerbutton','guild');
			$installer->add_menu_button('bosstrackerbutton','guild','bosses','ability_physical_taunt');
			$installer->add_menu_button('loottrackerbutton','guild','loot','racial_dwarf_findtreasure');
			$installer->add_menu_button('attendancetrackerbutton','guild','attendance','ability_rogue_disguise');
			$installer->add_menu_button('char_raids', 'char','char_raids','ability_dualwield');
			$installer->add_menu_button('char_bosses','char','char_bosses','ability_physical_taunt');
			$installer->add_menu_button('charloot','char','char_loot','racial_dwarf_findtreasure');
			$installer->add_menu_button('realm_bosses','realm','realm_bosses','ability_physical_taunt');
			$installer->add_menu_button('realmloot','realm','realm_loot','racial_dwarf_findtreasure');
	
		}
		if(version_compare('1.9.9.1024', $oldversion, '>') == true) {
			global $installer;
			
			$installer->remove_menu_button('raidtrackerbutton');
			$installer->remove_menu_button('bosstrackerbutton');
			$installer->remove_menu_button('loottrackerbutton');
			$installer->remove_menu_button('attendancetrackerbutton');
			$installer->remove_menu_button('char_raids');
			$installer->remove_menu_button('char_bosses');
			$installer->remove_menu_button('charloot');
			$installer->remove_menu_button('realm_bosses');
			$installer->remove_menu_button('realmloot');
	
			$installer->add_menu_button('raidtrackerbutton','guild');
			$installer->add_menu_button('bosstrackerbutton','guild','bosses','ability_creature_cursed_02');
			$installer->add_menu_button('loottrackerbutton','guild','loot','racial_dwarf_findtreasure');
			$installer->add_menu_button('attendancetrackerbutton','guild','attendance','ability_rogue_disguise');
			$installer->add_menu_button('manage_guild_raids','guild','manage_raids','ability_hunter_rapidkilling');
			$installer->add_menu_button('manage_guild_loot','guild','manage_loot','inv_jewelcrafting_goldenhare');
			$installer->add_menu_button('manage_guild_bosses','guild','manage_bosses','ability_druid_lunarguidance');
			$installer->add_menu_button('char_raids', 'char','char_raids','ability_dualwield');
			$installer->add_menu_button('char_bosses','char','char_bosses','ability_creature_cursed_02');
			$installer->add_menu_button('charloot','char','char_loot','racial_dwarf_findtreasure');
			$installer->add_menu_button('realm_bosses','realm','realm_bosses','ability_creature_cursed_02');
			$installer->add_menu_button('realmloot','realm','realm_loot','racial_dwarf_findtreasure');

    	}
		if(version_compare('1.9.9.1025', $oldversion, '>') == true) {
			global $installer;
	
			$installer->remove_menu_button('manage_guild_raids');
			$installer->remove_menu_button('manage_guild_loot');
			$installer->remove_menu_button('manage_guild_bosses');
			$installer->add_menu_button('manage_raids','util','manage_raids','ability_hunter_rapidkilling');
			$installer->add_menu_button('manage_loot','util','manage_loot','inv_jewelcrafting_goldenhare');
			$installer->add_menu_button('manage_bosses','util','manage_bosses','ability_druid_lunarguidance');
		}
		if( version_compare('1.9.9.1026', $oldversion, '>') == true) {
			global $installer;
			
			$installer->add_config("'1215', 'raidtracker_itemcache_expires', '90', 'text{4|4', 'raidtracker_items'");
		}
		if( version_compare('1.9.9.1027', $oldversion, '>') == true) {
			global $installer;

			$installer->remove_menu_button('char_raids');
			$installer->remove_menu_button('char_bosses');
			$installer->remove_menu_button('charloot');
			$installer->remove_menu_button('realm_bosses');
			$installer->remove_menu_button('realmloot');
			$installer->add_menu_button('char_raids', 'char','raids','ability_dualwield');
			$installer->add_menu_button('char_bosses','char','bosses','ability_creature_cursed_02');
			$installer->add_menu_button('charloot','char','loot','racial_dwarf_findtreasure');
			$installer->add_menu_button('realm_bosses','realm','bosses','ability_creature_cursed_02');
			$installer->add_menu_button('realmloot','realm','loot','racial_dwarf_findtreasure');
		}
		if( version_compare('1.9.9.1028', $oldversion, '>') == true) {
			global $installer;
			
			$installer->add_config("'1050', 'raidtracker_querydefault', '7776000', 'text{50|25', 'raidtracker_conf'");
		}
        return true;
    }

    /**
     * BackupSQL Function - Called before tables are destroyed
     *
     * @return bool
     */
    function BackupSQL($table) {
	    global $roster;
	    
	    $q = "SELECT * FROM ".$roster->db->table($table);
	    $result = $roster->db->query($q);
	    
	    // Loop through the data and separate it into an insert syntax
	    foreach(array_keys($result) as $key) {
		    
	    }
    }

    /**
     * Un-Install Function
     *
     * @return bool
     */
    function uninstall()
    {
        global $installer, $roster;

        $installer->remove_all_config();

        $installer->drop_table($installer->table('raids'));
        $installer->drop_table($installer->table('bosskills'));
        $installer->drop_table($installer->table('items'));
        $installer->drop_table($installer->table('raidmembers'));
        $installer->drop_table($installer->table('raidjoins'));
        $installer->drop_table($installer->table('raidleaves'));
        $installer->drop_table($installer->table('bossattend'));
        $installer->drop_table($installer->table('itemattend'));
		$installer->drop_table($installer->table('itemcache'));
		$installer->drop_table($installer->table('zonelist'));
		$installer->drop_table($installer->table('bosslist'));

        $installer->remove_all_menu_button();

        return true;
    }
}
?>
